import{s as we,n as Ce,o as Oe}from"../chunks/scheduler.8c3d61f6.js";import{S as Le,i as ke,g as d,s as n,r as u,A as Ie,h as a,f as t,c as o,j as x,u as p,x as P,k as E,y as s,a as c,v as m,d as f,t as h,w as g}from"../chunks/index.da70eac4.js";import{D as G}from"../chunks/Docstring.ee4b6913.js";import{H as Se,E as qe}from"../chunks/EditOnGithub.1e64e623.js";function He(be){let _,R,j,W,M,J,T,De='The <code>DPMSolverSDEScheduler</code> is inspired by the stochastic sampler from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper, and the scheduler is ported from and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',Q,y,X,i,w,ae,N,$e=`DPMSolverSDEScheduler implements the stochastic sampler from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based
Generative Models</a> paper.`,le,U,xe=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,ce,S,C,ue,V,Pe=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,pe,b,O,me,A,Ee="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",fe,D,L,he,z,Me="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",ge,$,k,_e,B,Te=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,Y,I,Z,v,q,ve,F,ye="Base class for the output of a scheduler’s <code>step</code> function.",ee,H,te,K,se;return M=new Se({props:{title:"DPMSolverSDEScheduler",local:"dpmsolversdescheduler",headingTag:"h1"}}),y=new Se({props:{title:"DPMSolverSDEScheduler",local:"diffusers.DPMSolverSDEScheduler",headingTag:"h2"}}),w=new G({props:{name:"class diffusers.DPMSolverSDEScheduler",anchor:"diffusers.DPMSolverSDEScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"noise_sampler_seed",val:": Optional = None"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.DPMSolverSDEScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.00085) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.DPMSolverSDEScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.012) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.DPMSolverSDEScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.DPMSolverSDEScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.DPMSolverSDEScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.DPMSolverSDEScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.DPMSolverSDEScheduler.noise_sampler_seed",description:`<strong>noise_sampler_seed</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The random seed to use for the noise sampler. If <code>None</code>, a random seed is generated.`,name:"noise_sampler_seed"},{anchor:"diffusers.DPMSolverSDEScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.DPMSolverSDEScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L123"}}),C=new G({props:{name:"scale_model_input",anchor:"diffusers.DPMSolverSDEScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"timestep",val:": Union"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.DPMSolverSDEScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L258",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),O=new G({props:{name:"set_begin_index",anchor:"diffusers.DPMSolverSDEScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L248"}}),L=new G({props:{name:"set_timesteps",anchor:"diffusers.DPMSolverSDEScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": Union = None"},{name:"num_train_timesteps",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.DPMSolverSDEScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L285"}}),k=new G({props:{name:"step",anchor:"diffusers.DPMSolverSDEScheduler.step",parameters:[{name:"model_output",val:": Union"},{name:"timestep",val:": Union"},{name:"sample",val:": Union"},{name:"return_dict",val:": bool = True"},{name:"s_noise",val:": float = 1.0"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code> or <code>np.ndarray</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DPMSolverSDEScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code> or <code>torch.Tensor</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.DPMSolverSDEScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code> or <code>np.ndarray</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.DPMSolverSDEScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/schedulers/edm_multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"},{anchor:"diffusers.DPMSolverSDEScheduler.step.s_noise",description:`<strong>s_noise</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
Scaling factor for noise added to the sample.`,name:"s_noise"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L415",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/main/en/api/schedulers/edm_multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><a
  href="/docs/diffusers/main/en/api/schedulers/edm_multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),I=new Se({props:{title:"SchedulerOutput",local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",headingTag:"h2"}}),q=new G({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": Tensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_utils.py#L60"}}),H=new qe({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/dpm_sde.md"}}),{c(){_=d("meta"),R=n(),j=d("p"),W=n(),u(M.$$.fragment),J=n(),T=d("p"),T.innerHTML=De,Q=n(),u(y.$$.fragment),X=n(),i=d("div"),u(w.$$.fragment),ae=n(),N=d("p"),N.innerHTML=$e,le=n(),U=d("p"),U.innerHTML=xe,ce=n(),S=d("div"),u(C.$$.fragment),ue=n(),V=d("p"),V.textContent=Pe,pe=n(),b=d("div"),u(O.$$.fragment),me=n(),A=d("p"),A.textContent=Ee,fe=n(),D=d("div"),u(L.$$.fragment),he=n(),z=d("p"),z.textContent=Me,ge=n(),$=d("div"),u(k.$$.fragment),_e=n(),B=d("p"),B.textContent=Te,Y=n(),u(I.$$.fragment),Z=n(),v=d("div"),u(q.$$.fragment),ve=n(),F=d("p"),F.innerHTML=ye,ee=n(),u(H.$$.fragment),te=n(),K=d("p"),this.h()},l(e){const r=Ie("svelte-u9bgzb",document.head);_=a(r,"META",{name:!0,content:!0}),r.forEach(t),R=o(e),j=a(e,"P",{}),x(j).forEach(t),W=o(e),p(M.$$.fragment,e),J=o(e),T=a(e,"P",{"data-svelte-h":!0}),P(T)!=="svelte-f261ri"&&(T.innerHTML=De),Q=o(e),p(y.$$.fragment,e),X=o(e),i=a(e,"DIV",{class:!0});var l=x(i);p(w.$$.fragment,l),ae=o(l),N=a(l,"P",{"data-svelte-h":!0}),P(N)!=="svelte-2gqyak"&&(N.innerHTML=$e),le=o(l),U=a(l,"P",{"data-svelte-h":!0}),P(U)!=="svelte-linuuh"&&(U.innerHTML=xe),ce=o(l),S=a(l,"DIV",{class:!0});var re=x(S);p(C.$$.fragment,re),ue=o(re),V=a(re,"P",{"data-svelte-h":!0}),P(V)!=="svelte-1rkfgpx"&&(V.textContent=Pe),re.forEach(t),pe=o(l),b=a(l,"DIV",{class:!0});var ne=x(b);p(O.$$.fragment,ne),me=o(ne),A=a(ne,"P",{"data-svelte-h":!0}),P(A)!=="svelte-1k141rk"&&(A.textContent=Ee),ne.forEach(t),fe=o(l),D=a(l,"DIV",{class:!0});var oe=x(D);p(L.$$.fragment,oe),he=o(oe),z=a(oe,"P",{"data-svelte-h":!0}),P(z)!=="svelte-1vzm9q"&&(z.textContent=Me),oe.forEach(t),ge=o(l),$=a(l,"DIV",{class:!0});var ie=x($);p(k.$$.fragment,ie),_e=o(ie),B=a(ie,"P",{"data-svelte-h":!0}),P(B)!=="svelte-hi84tp"&&(B.textContent=Te),ie.forEach(t),l.forEach(t),Y=o(e),p(I.$$.fragment,e),Z=o(e),v=a(e,"DIV",{class:!0});var de=x(v);p(q.$$.fragment,de),ve=o(de),F=a(de,"P",{"data-svelte-h":!0}),P(F)!=="svelte-6ojmkw"&&(F.innerHTML=ye),de.forEach(t),ee=o(e),p(H.$$.fragment,e),te=o(e),K=a(e,"P",{}),x(K).forEach(t),this.h()},h(){E(_,"name","hf:doc:metadata"),E(_,"content",Ne),E(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),E(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),E(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),E($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),E(i,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),E(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){s(document.head,_),c(e,R,r),c(e,j,r),c(e,W,r),m(M,e,r),c(e,J,r),c(e,T,r),c(e,Q,r),m(y,e,r),c(e,X,r),c(e,i,r),m(w,i,null),s(i,ae),s(i,N),s(i,le),s(i,U),s(i,ce),s(i,S),m(C,S,null),s(S,ue),s(S,V),s(i,pe),s(i,b),m(O,b,null),s(b,me),s(b,A),s(i,fe),s(i,D),m(L,D,null),s(D,he),s(D,z),s(i,ge),s(i,$),m(k,$,null),s($,_e),s($,B),c(e,Y,r),m(I,e,r),c(e,Z,r),c(e,v,r),m(q,v,null),s(v,ve),s(v,F),c(e,ee,r),m(H,e,r),c(e,te,r),c(e,K,r),se=!0},p:Ce,i(e){se||(f(M.$$.fragment,e),f(y.$$.fragment,e),f(w.$$.fragment,e),f(C.$$.fragment,e),f(O.$$.fragment,e),f(L.$$.fragment,e),f(k.$$.fragment,e),f(I.$$.fragment,e),f(q.$$.fragment,e),f(H.$$.fragment,e),se=!0)},o(e){h(M.$$.fragment,e),h(y.$$.fragment,e),h(w.$$.fragment,e),h(C.$$.fragment,e),h(O.$$.fragment,e),h(L.$$.fragment,e),h(k.$$.fragment,e),h(I.$$.fragment,e),h(q.$$.fragment,e),h(H.$$.fragment,e),se=!1},d(e){e&&(t(R),t(j),t(W),t(J),t(T),t(Q),t(X),t(i),t(Y),t(Z),t(v),t(ee),t(te),t(K)),t(_),g(M,e),g(y,e),g(w),g(C),g(O),g(L),g(k),g(I,e),g(q),g(H,e)}}}const Ne='{"title":"DPMSolverSDEScheduler","local":"dpmsolversdescheduler","sections":[{"title":"DPMSolverSDEScheduler","local":"diffusers.DPMSolverSDEScheduler","sections":[],"depth":2},{"title":"SchedulerOutput","local":"diffusers.schedulers.scheduling_utils.SchedulerOutput","sections":[],"depth":2}],"depth":1}';function Ue(be){return Oe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fe extends Le{constructor(_){super(),ke(this,_,Ue,He,we,{})}}export{Fe as component};
