import{s as Z,n as ee,o as te}from"../chunks/scheduler.8c3d61f6.js";import{S as ne,i as oe,g as d,s as r,r as D,A as re,h as l,f as n,c as s,j as O,u as F,x as S,k as q,y as m,a,v as w,d as y,t as j,w as k}from"../chunks/index.da70eac4.js";import{D as X}from"../chunks/Docstring.ee4b6913.js";import{H as Y,E as se}from"../chunks/EditOnGithub.1e64e623.js";function ae(G){let i,L,v,P,u,N,p,B='A Transformer model for image-like data from <a href="https://blackforestlabs.ai/announcing-black-forest-labs/" rel="nofollow">Flux</a>.',z,h,E,o,_,R,x,J="The Transformer model introduced in Flux.",U,T,K='Reference: <a href="https://blackforestlabs.ai/announcing-black-forest-labs/" rel="nofollow">https://blackforestlabs.ai/announcing-black-forest-labs/</a>',V,c,g,W,$,Q='The <a href="/docs/diffusers/main/en/api/models/flux_transformer#diffusers.FluxTransformer2DModel">FluxTransformer2DModel</a> forward method.',C,b,H,M,A;return u=new Y({props:{title:"FluxTransformer2DModel",local:"fluxtransformer2dmodel",headingTag:"h1"}}),h=new Y({props:{title:"FluxTransformer2DModel",local:"diffusers.FluxTransformer2DModel",headingTag:"h2"}}),_=new X({props:{name:"class diffusers.FluxTransformer2DModel",anchor:"diffusers.FluxTransformer2DModel",parameters:[{name:"patch_size",val:": int = 1"},{name:"in_channels",val:": int = 64"},{name:"num_layers",val:": int = 19"},{name:"num_single_layers",val:": int = 38"},{name:"attention_head_dim",val:": int = 128"},{name:"num_attention_heads",val:": int = 24"},{name:"joint_attention_dim",val:": int = 4096"},{name:"pooled_projection_dim",val:": int = 768"},{name:"guidance_embeds",val:": bool = False"},{name:"axes_dims_rope",val:": List = [16, 56, 56]"}],parametersDescription:[{anchor:"diffusers.FluxTransformer2DModel.patch_size",description:"<strong>patch_size</strong> (<code>int</code>) &#x2014; Patch size to turn the input data into small patches.",name:"patch_size"},{anchor:"diffusers.FluxTransformer2DModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014; The number of channels in the input.",name:"in_channels"},{anchor:"diffusers.FluxTransformer2DModel.num_layers",description:"<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 18) &#x2014; The number of layers of MMDiT blocks to use.",name:"num_layers"},{anchor:"diffusers.FluxTransformer2DModel.num_single_layers",description:"<strong>num_single_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 18) &#x2014; The number of layers of single DiT blocks to use.",name:"num_single_layers"},{anchor:"diffusers.FluxTransformer2DModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014; The number of channels in each head.",name:"attention_head_dim"},{anchor:"diffusers.FluxTransformer2DModel.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 18) &#x2014; The number of heads to use for multi-head attention.",name:"num_attention_heads"},{anchor:"diffusers.FluxTransformer2DModel.joint_attention_dim",description:"<strong>joint_attention_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; The number of <code>encoder_hidden_states</code> dimensions to use.",name:"joint_attention_dim"},{anchor:"diffusers.FluxTransformer2DModel.pooled_projection_dim",description:"<strong>pooled_projection_dim</strong> (<code>int</code>) &#x2014; Number of dimensions to use when projecting the <code>pooled_projections</code>.",name:"pooled_projection_dim"},{anchor:"diffusers.FluxTransformer2DModel.guidance_embeds",description:"<strong>guidance_embeds</strong> (<code>bool</code>, defaults to False) &#x2014; Whether to use guidance embeddings.",name:"guidance_embeds"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/transformers/transformer_flux.py#L235"}}),g=new X({props:{name:"forward",anchor:"diffusers.FluxTransformer2DModel.forward",parameters:[{name:"hidden_states",val:": Tensor"},{name:"encoder_hidden_states",val:": Tensor = None"},{name:"pooled_projections",val:": Tensor = None"},{name:"timestep",val:": LongTensor = None"},{name:"img_ids",val:": Tensor = None"},{name:"txt_ids",val:": Tensor = None"},{name:"guidance",val:": Tensor = None"},{name:"joint_attention_kwargs",val:": Optional = None"},{name:"controlnet_block_samples",val:" = None"},{name:"controlnet_single_block_samples",val:" = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.FluxTransformer2DModel.forward.hidden_states",description:`<strong>hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch size, channel, height, width)</code>) &#x2014;
Input <code>hidden_states</code>.`,name:"hidden_states"},{anchor:"diffusers.FluxTransformer2DModel.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch size, sequence_len, embed_dims)</code>) &#x2014;
Conditional embeddings (embeddings computed from the input conditions such as prompts) to use.`,name:"encoder_hidden_states"},{anchor:"diffusers.FluxTransformer2DModel.forward.pooled_projections",description:`<strong>pooled_projections</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, projection_dim)</code>) &#x2014; Embeddings projected
from the embeddings of input conditions.`,name:"pooled_projections"},{anchor:"diffusers.FluxTransformer2DModel.forward.timestep",description:`<strong>timestep</strong> ( <code>torch.LongTensor</code>) &#x2014;
Used to indicate denoising step.
block_controlnet_hidden_states &#x2014; (<code>list</code> of <code>torch.Tensor</code>):
A list of tensors that if specified are added to the residuals of transformer blocks.`,name:"timestep"},{anchor:"diffusers.FluxTransformer2DModel.forward.joint_attention_kwargs",description:`<strong>joint_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/attention_processor.py" rel="nofollow">diffusers.models.attention_processor</a>.`,name:"joint_attention_kwargs"},{anchor:"diffusers.FluxTransformer2DModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>~models.transformer_2d.Transformer2DModelOutput</code> instead of a plain
tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/transformers/transformer_flux.py#L315",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If <code>return_dict</code> is True, an <code>~models.transformer_2d.Transformer2DModelOutput</code> is returned, otherwise a
<code>tuple</code> where the first element is the sample tensor.</p>
`}}),b=new se({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/models/flux_transformer.md"}}),{c(){i=d("meta"),L=r(),v=d("p"),P=r(),D(u.$$.fragment),N=r(),p=d("p"),p.innerHTML=B,z=r(),D(h.$$.fragment),E=r(),o=d("div"),D(_.$$.fragment),R=r(),x=d("p"),x.textContent=J,U=r(),T=d("p"),T.innerHTML=K,V=r(),c=d("div"),D(g.$$.fragment),W=r(),$=d("p"),$.innerHTML=Q,C=r(),D(b.$$.fragment),H=r(),M=d("p"),this.h()},l(e){const t=re("svelte-u9bgzb",document.head);i=l(t,"META",{name:!0,content:!0}),t.forEach(n),L=s(e),v=l(e,"P",{}),O(v).forEach(n),P=s(e),F(u.$$.fragment,e),N=s(e),p=l(e,"P",{"data-svelte-h":!0}),S(p)!=="svelte-e6h9db"&&(p.innerHTML=B),z=s(e),F(h.$$.fragment,e),E=s(e),o=l(e,"DIV",{class:!0});var f=O(o);F(_.$$.fragment,f),R=s(f),x=l(f,"P",{"data-svelte-h":!0}),S(x)!=="svelte-19p4ty0"&&(x.textContent=J),U=s(f),T=l(f,"P",{"data-svelte-h":!0}),S(T)!=="svelte-mxgguy"&&(T.innerHTML=K),V=s(f),c=l(f,"DIV",{class:!0});var I=O(c);F(g.$$.fragment,I),W=s(I),$=l(I,"P",{"data-svelte-h":!0}),S($)!=="svelte-4l0nim"&&($.innerHTML=Q),I.forEach(n),f.forEach(n),C=s(e),F(b.$$.fragment,e),H=s(e),M=l(e,"P",{}),O(M).forEach(n),this.h()},h(){q(i,"name","hf:doc:metadata"),q(i,"content",ie),q(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),q(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){m(document.head,i),a(e,L,t),a(e,v,t),a(e,P,t),w(u,e,t),a(e,N,t),a(e,p,t),a(e,z,t),w(h,e,t),a(e,E,t),a(e,o,t),w(_,o,null),m(o,R),m(o,x),m(o,U),m(o,T),m(o,V),m(o,c),w(g,c,null),m(c,W),m(c,$),a(e,C,t),w(b,e,t),a(e,H,t),a(e,M,t),A=!0},p:ee,i(e){A||(y(u.$$.fragment,e),y(h.$$.fragment,e),y(_.$$.fragment,e),y(g.$$.fragment,e),y(b.$$.fragment,e),A=!0)},o(e){j(u.$$.fragment,e),j(h.$$.fragment,e),j(_.$$.fragment,e),j(g.$$.fragment,e),j(b.$$.fragment,e),A=!1},d(e){e&&(n(L),n(v),n(P),n(N),n(p),n(z),n(E),n(o),n(C),n(H),n(M)),n(i),k(u,e),k(h,e),k(_),k(g),k(b,e)}}}const ie='{"title":"FluxTransformer2DModel","local":"fluxtransformer2dmodel","sections":[{"title":"FluxTransformer2DModel","local":"diffusers.FluxTransformer2DModel","sections":[],"depth":2}],"depth":1}';function de(G){return te(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ue extends ne{constructor(i){super(),oe(this,i,de,ae,Z,{})}}export{ue as component};
